[#ftl]
[#compress]

  [#assign taskpurpose       = "OS_TASK_NOTHING"]
  [#assign tasks             = 2]
  [#assign extendedtasks     = 0]

  [#assign timerpurpose      = "OS_TIMER_NOTHING"]
  [#assign timers            = 0]
  [#assign extendedtimers    = 0]

  [#assign mutexes           = 0]
  [#assign semaphores        = 0]
  [#assign semavalue         = 0]
  [#assign mailboxes         = 0]
  [#assign queues            = 0]
  [#assign events            = 0]
  [#assign mempools          = 0]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_TASK_PURPOSE"]
          [#assign taskpurpose     = definition.value]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TASKS"]
          [#assign tasks           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_TIMER_PURPOSE"]
          [#assign timerpurpose    = definition.value]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TIMERS"]
          [#assign timers          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores      = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes       = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_QUEUES"]
          [#assign queues          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EVENTS"]
          [#assign events          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index = 0]

  [#if tasks == 0]
  [#else]
    [#list 1..tasks as i]
      /* USER CODE BEGIN Task${index} */
      /**
      #t* @brief  Function implementing Task${index}.
      #t* @retval None
      #t*/
      void Task${index}(void) {
        #twhile (1) {
          [#if taskpurpose == "OS_TASK_MUTEX"]
            [#if mutexes == 0]
              #t#t// Task was configured to utilize a mutex, but no mutex was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_MUTEX_LockBlocked(&MutexCB0);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_SEMA"]
            [#if semaphores == 0]
              #t#t// Task was configured to utilize a semaphore, but no semaphore was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_SEMAPHORE_TakeBlocked(&SemaphoreCB0);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_EVENT"]
            #t#tOS_TASKEVENT_GetBlocked(0xFF);
          [/#if]
          [#if taskpurpose == "OS_TASK_EVENTOBJ"]
            [#if events == 0]
              #t#t// Task was configured to utilize an event object, but no event object was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_EVENT_GetMaskBlocked(&EventObjectCB0, 0xFF);
            [/#if]
          [/#if]
          #t#t//
          #t#t// Application code
          #t#t//
          [#if taskpurpose == "OS_TASK_DELAY"]
            #t#tOS_TASK_Delay((OS_TIME)100);
          [/#if]
          [#if taskpurpose == "OS_TASK_TOGGLE_LED"]
            #t#tBSP_LED_Toggle(${i?item_cycle('LED0', 'LED1', 'LED2', 'LED3')});
            #t#tOS_TASK_Delay((OS_TIME)100);
          [/#if]
          [#if taskpurpose == "OS_TASK_MAILBOX"]
            [#if mailboxes == 0]
              #t#t// Task was configured to utilize a mailbox, but no mailbox was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_MAILBOX_PutBlocked(&MailboxCB0, "\nHello World !\0");
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_QUEUE"]
            [#if queues == 0]
              #t#t// Task was configured to utilize a queue, but no queue was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_QUEUE_PutBlocked(&QueueCB0, "\nHello World !\0", 16);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_MUTEX"]
            [#if mutexes == 0]
            [#else]
              #t#tOS_MUTEX_Unlock(&MutexCB0);
            [/#if]
          [/#if]
        #t}
      }
      /* USER CODE END Task${index} */
      #n
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if extendedtasks == 0]
  [#else]
    [#list 1..extendedtasks as i]
      /* USER CODE BEGIN TaskEx${index} */
      /**
      #t* @brief  Function implementing TaskEx${index}.
      #t* @param  pContext: Not used (yet)
      #t* @retval None
      #t*/
      void TaskEx${index}(void* pContext) {
        #twhile (1) {
          #t#tOS_USE_PARA(pContext);#t// Avoid compiler warning for (yet) unused parameter
          [#if taskpurpose == "OS_TASK_MUTEX"]
            [#if mutexes == 0]
              #t#t// Task was configured to utilize a mutex, but no mutex was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_MUTEX_LockBlocked(&MutexCB0);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_SEMA"]
            [#if semaphores == 0]
              #t#t// Task was configured to utilize a semaphore, but no semaphore was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_SEMAPHORE_TakeBlocked(&SemaphoreCB0);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_EVENT"]
            #t#t;OS_TASKEVENT_GetBlocked(0xFF);
          [/#if]
          [#if taskpurpose == "OS_TASK_EVENTOBJ"]
            [#if events == 0]
              #t#t// Task was configured to utilize an event object, but no event object was generated in the STM32CubeMX project.
            [#else]
              #t#t;OS_EVENT_GetMaskBlocked(&EventObjectCB0, 0xFF);
            [/#if]
          [/#if]
          #t#t//
          #t#t// Application code
          #t#t//
          [#if taskpurpose == "OS_TASK_DELAY"]
            #t#tOS_TASK_Delay((OS_TIME)100);
          [/#if]
          [#if taskpurpose == "OS_TASK_TOGGLE_LED"]
            #t#tBSP_LED_Toggle(${i?item_cycle('LED0', 'LED1', 'LED2', 'LED3')});
            #t#tOS_TASK_Delay((OS_TIME)100);
          [/#if]
          [#if taskpurpose == "OS_TASK_MAILBOX"]
            [#if mailboxes == 0]
              #t#t// Task was configured to utilize a mailbox, but no mailbox was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_MAILBOX_PutBlocked(&MailboxCB0, "\nHello World !\0");
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_QUEUE"]
            [#if queues == 0]
              #t#t// Task was configured to utilize a queue, but no queue was generated in the STM32CubeMX project.
            [#else]
              #t#tOS_QUEUE_PutBlocked(&QueueCB0, "\nHello World !\0", 16);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_MUTEX"]
            [#if mutexes == 0]
            [#else]
              #t#tOS_MUTEX_Unlock(&MutexCB0);
            [/#if]
          [/#if]
        #t}
      }
      /* USER CODE END TaskEx${index} */
      #n
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if timers == 0]
  [#else]
    [#list 1..timers as i]
      /* USER CODE BEGIN Timer${index} */
      /**
      #t* @brief  Function implementing Timer${index}.
      #t* @retval None
      #t*/
      void Timer${index}(void) {
        #t//
        #t// Application code
        #t//
        [#if timerpurpose=="OS_TIMER_RESTART"]
          #tOS_TIMER_Restart(&TimerCB${index});#t// Make timer periodic
        [/#if]
        [#if timerpurpose=="OS_TIMER_TOGGLE_LED"]
          #tBSP_LED_Toggle(${i?item_cycle('LED0', 'LED1', 'LED2', 'LED3')});
          #tOS_TIMER_Restart(&TimerCB${index});#t// Make timer periodic
        [/#if]
      }
      /* USER CODE END Timer${index} */
      #n
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      /* USER CODE BEGIN TimerEx${index} */
      /**
      #t* @brief  Function implementing TimerEx${index}.
      #t* @param  pData: Not used (yet)
      #t* @retval None
      #t*/
      void TimerEx${index}(void* pData) {
        #tOS_USE_PARA(pData);#t// Avoid compiler warning for (yet) unused parameter
        #t//
        #t// Application code
        #t//
        [#if timerpurpose=="OS_TIMER_RESTART"]
          #tOS_TIMER_RestartEx((OS_TIMER_EX*)OS_Global.pCurrentTimer);#t// Make timer periodic
        [/#if]
        [#if timerpurpose=="OS_TIMER_TOGGLE_LED"]
          #tBSP_LED_Toggle(${i?item_cycle('LED0', 'LED1', 'LED2', 'LED3')});
          #tOS_TIMER_RestartEx((OS_TIMER_EX*)OS_Global.pCurrentTimer);#t// Make timer periodic
        [/#if]
      }
      /* USER CODE END TimerEx${index} */
      #n
      [#assign index = index + 1]
    [/#list]
  [/#if]

[/#compress]