[#ftl]
[#compress]

  [#assign taskpurpose       = "OS_TASK_NOTHING"]
  [#assign extendedtasks     = 2]

  [#assign timerpurpose      = "OS_TIMER_NOTHING"]
  [#assign extendedtimers    = 2]

  [#assign mutexes           = 0]
  [#assign semaphores        = 0]
  [#assign semavalue         = 0]
  [#assign mailboxes         = 0]
  [#assign events            = 0]
  [#assign mempools          = 0]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_TASK_PURPOSE_CMSIS2"]
          [#assign taskpurpose      = definition.value]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_TIMER_PURPOSE"]
          [#assign timerpurpose     = definition.value]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores       = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes        = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EVENTS"]
          [#assign events           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index  = 0]

  [#if extendedtasks == 0]
  [#else]
    [#list 1..extendedtasks as i]
      /* USER CODE BEGIN TaskEx${index} */
      /**
      #t* @brief  Function implementing TaskEx${index}.
      #t* @param  pContext: Not used (yet)
      #t* @retval None
      #t*/
      void TaskEx${index}(void* pContext) {
        #twhile (1) {
          #t#t(void)(pContext);#t// Avoid compiler warning for (yet) unused parameter
          [#if taskpurpose == "OS_TASK_MUTEX"]
            [#if mutexes == 0]
              #t#t// Task was configured to utilize a mutex, but no mutex was generated in the STM32CubeMX project.
            [#else]
              #t#tosMutexAcquire(Mutex0, osWaitForever);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_SEMA"]
            [#if semaphores == 0]
              #t#t// Task was configured to utilize a semaphore, but no semaphore was generated in the STM32CubeMX project.
            [#else]
              #t#tosSemaphoreAcquire(Semaphore0, osWaitForever);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_EVENTOBJ"]
            #t#tosEventFlagsWait(EventObject0, 0xFF, osFlagsWaitAny, osWaitForever);
          [/#if]
          #t#t//
          #t#t// Application code
          #t#t//
          [#if taskpurpose == "OS_TASK_DELAY"]
            #t#tosDelay((uint32_t)100);
          [/#if]
          [#if taskpurpose == "OS_TASK_TOGGLE_LED"]
            #t#tBSP_LED_Toggle(${i?item_cycle('LED0', 'LED1', 'LED2', 'LED3')});
            #t#tosDelay((uint32_t)100);
          [/#if]
          [#if taskpurpose == "OS_TASK_MAILBOX"]
            [#if mailboxes == 0]
              #t#t// Task was configured to utilize a mailbox, but no mailbox was generated in the STM32CubeMX project.
            [#else]
              #t#tchar message[16];
              #t#tstrcpy(message, "\nHello World !\0");
              #t#tosMessageQueuePut(Mailbox0, message, 0, osWaitForever);
            [/#if]
          [/#if]
          [#if taskpurpose == "OS_TASK_MUTEX"]
            [#if mutexes == 0]
            [#else]
              #t#tosMutexRelease (Mutex0);
            [/#if]
          [/#if]
        #t}
      }
      /* USER CODE END TaskEx${index} */
      #n
      [#assign index  = index + 1]
    [/#list]
  [/#if]

  [#assign index  = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      /* USER CODE BEGIN TimerEx${index} */
      /**
      #t* @brief  Function implementing TimerEx${index}.
      #t* @param  pData: Not used (yet)
      #t* @retval None
      #t*/
      void TimerEx${index}(void* pData) {
        #t(void)(pData);#t// Avoid compiler warning for (yet) unused parameter
        #t//
        #t// Application code
        #t//
        [#if timerpurpose=="OS_TIMER_TOGGLE_LED"]
          #tBSP_LED_Toggle(${i?item_cycle('LED0', 'LED1', 'LED2', 'LED3')});
        [/#if]
      }
      /* USER CODE END TimerEx${index} */
      #n
      [#assign index = index + 1]
    [/#list]
  [/#if]

[/#compress]