[#ftl]
[#compress]

  [#assign stacksize         = 128]
  [#assign tasks             = 2]
  [#assign extendedtasks     = 0]
  [#assign extendedtaskinst  = 1]

  [#assign timers            = 0]
  [#assign extendedtimers    = 0]
  [#assign extendedtimerinst = 1]

  [#assign mutexes           = 0]

  [#assign semaphores        = 0]

  [#assign mailboxes         = 0]
  [#assign mailboxmsgnum     = 10]
  [#assign mailboxmsgsize    = 20]

  [#assign queues            = 0]
  [#assign queuebuffersize   = 100]

  [#assign events            = 0]

  [#assign mempools          = 0]
  [#assign mempoolblocknum   = 10]
  [#assign mempoolblocksize  = 20]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_TASK_STACK_SIZE"]
          [#assign stacksize         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TASKS"]
          [#assign tasks             = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TASKS"]
          [#assign extendedtaskinst  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TIMERS"]
          [#assign timers            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TIMERS"]
          [#assign extendedtimerinst = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores        = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_NUM_MESSAGES"]
          [#assign mailboxmsgnum     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_SIZE_MESSAGE"]
          [#assign mailboxmsgsize    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_QUEUES"]
          [#assign queues            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_QUEUE_BUFFER_SIZE"]
          [#assign queuebuffersize   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EVENTS"]
          [#assign events            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MEMPOOLS"]
          [#assign mempools          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_NUM_BLOCKS"]
          [#assign mempoolblocknum   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize  = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index = 0]

  [#if tasks  == 0]
  [#else]
    [#list 1..tasks as i]
      #n
      /* USER CODE BEGIN Declarations_Task${index} */
      static OS_TASK#t#t#t#t TaskCB${index};#t#t#t#t#t#t#t#t#t// Control block for Task${index}
      static OS_STACKPTR int Stack${index}[${stacksize}];#t#t#t#t#t#t#t// Stack for Task${index}
      /* USER CODE END Declarations_Task${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtasks  == 0]
  [#else]
    [#list 1..extendedtasks as i]
      [#if extendedtaskinst == 0]
      [#else]
        [#list 1..extendedtaskinst as j]
          #n
          /* USER CODE BEGIN Declarations_TaskEx${index}_Inst${index2} */
          static OS_TASK#t#t#t#t TaskCBEx${index}_Inst${index2};#t#t#t#t#t// Control block for TaskEx${index}_Inst${index2}
          static OS_STACKPTR int StackEx${index}_Inst${index2}[${stacksize}];#t#t#t// Stack for TaskEx${index}_Inst${index2}
          /* USER CODE END Declarations_TaskEx${index}_Inst${index2} */
          [#assign index2 = index2 + 1]
        [/#list]
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if timers == 0]
  [#else]
    [#list 1..timers as i]
      #n
      /* USER CODE BEGIN Declaration_Timer${index} */
      static OS_TIMER#t#t#t#tTimerCB${index};#t#t#t#t#t#t#t#t // Control block for Timer${index}
      /* USER CODE END Declaration_Timer${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      [#if extendedtimerinst  == 0]
      [#else]
        [#list 1..extendedtimerinst as j]
          #n
          /* USER CODE BEGIN Declaration_TimerEx${index}_Inst${index2} */
          static OS_TIMER_EX#t#t TimerCBEx${index}_Inst${index2};#t#t#t#t // Control block for TimerEx${index}_Inst${index2}
          /* USER CODE END Declaration_TimerEx${index}_Inst${index2} */
          [#assign index2 = index2 + 1]
        [/#list]
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mutexes == 0]
  [#else]
    [#list 1..mutexes as i]
      #n
      /* USER CODE BEGIN Declaration_Mutex${index} */
      static OS_MUTEX#t#t#t#tMutexCB${index};#t#t#t#t#t#t#t#t // Control block for Mutex${index}
      /* USER CODE END Declaration_Mutex${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if semaphores == 0]
  [#else]
    [#list 1..semaphores as i]
      #n
      /* USER CODE BEGIN Declaration_Semaphore${index} */
      static OS_SEMAPHORE#t#tSemaphoreCB${index};#t#t#t#t#t#t // Control block for Semaphore${index}
      /* USER CODE END Declaration_Semaphore${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mailboxes == 0]
  [#else]
    [#list 1..mailboxes as i]
      #n
      /* USER CODE BEGIN Declarations_Mailbox${index} */
      static OS_MAILBOX#t#t#tMailboxCB${index};#t#t#t#t#t#t#t // Control block for Mailbox${index}
      static char#t#t#t#t#t#tMailboxBuffer${index}[${mailboxmsgnum} * ${mailboxmsgsize}];#t// Message buffer for Mailbox${index}
      /* USER CODE END Declarations_Mailbox${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if queues == 0]
  [#else]
    [#list 1..queues as i]
      #n
      /* USER CODE BEGIN Declarations_Queue${index} */
      static OS_QUEUE#t#t#t#tQueueCB${index};#t#t#t#t#t#t#t#t // Control block for Queue${index}
      static char#t#t#t#t#t#tQueueBuffer${index}[${queuebuffersize}];#t#t#t#t// Message buffer for Queue${index}
      /* USER CODE END Declarations_Queue${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if events == 0]
  [#else]
    [#list 1..events as i]
      #n
      /* USER CODE BEGIN Declaration_EventObject${index} */
      static OS_EVENT#t#t#t#tEventObjectCB${index};#t#t#t#t#t // Control block for EventObject${index}
      /* USER CODE END Declaration_EventObject${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mempools == 0]
  [#else]
    [#list 1..mempools as i]
      #n
      /* USER CODE BEGIN Declarations_MemPool${index} */
      static OS_MEMPOOL#t#t#tMemPoolCB${index};#t#t#t#t#t#t#t // Control block for MemPool${index}
      static char#t#t#t#t#t#tMemPoolMem${index}[${mempoolblocknum} * ${mempoolblocksize}];#t#t // Memory for MemPool${index}
      /* USER CODE END Declarations_MemPool${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]
  #n

[/#compress]