[#ftl]
[#compress]

  [#assign stacksize         = 128]
  [#assign priority          = "osPriorityNormal"]
  [#assign extendedtasks     = 2]
  [#assign extendedtaskinst  = 1]

  [#assign extendedtimers    = 2]
  [#assign extendedtimerinst = 1]

  [#assign mutexes           = 0]

  [#assign semaphores        = 0]

  [#assign mailboxes         = 0]
  [#assign mailboxmsgnum     = 10]
  [#assign mailboxmsgsize    = 20]

  [#assign queues            = 0]
  [#assign queuebuffersize   = 100]

  [#assign mempools          = 0]
  [#assign mempoolblocknum   = 10]
  [#assign mempoolblocksize  = 20]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_TASK_PRIORITY_CMSIS"]
          [#assign priority          = definition.value]
        [/#if]
        [#if definition.name == "OS_TASK_STACK_SIZE"]
          [#assign stacksize         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TASKS"]
          [#assign extendedtaskinst  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TIMERS"]
          [#assign timers            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores        = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_NUM_MESSAGES"]
          [#assign mailboxmsgnum     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_SIZE_MESSAGE"]
          [#assign mailboxmsgsize    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_QUEUES"]
          [#assign queues            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_QUEUE_BUFFER_SIZE"]
          [#assign queuebuffersize   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MEMPOOLS"]
          [#assign mempools          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_NUM_BLOCKS"]
          [#assign mempoolblocknum   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize  = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtasks  == 0]
  [#else]
    [#list 1..extendedtasks as i]
      [#if extendedtaskinst == 0]
      [#else]
        #n
        /* USER CODE BEGIN Declarations_TaskEx${index} */
        static void TaskEx${index}(void const* pContext);#t#t#t#t// Prototype for TaskEx${index}
        osThreadDef (TaskEx${index}, ${priority}, ${extendedtaskinst}, ${stacksize});#t// Definition of TaskEx${index}
        [#list 1..extendedtaskinst as j]
          osThreadId TaskEx${index}_Inst${index2};#t#t#t#t#t#t#t#t#t#t#t#t // Handle for TaskEx${index}_Inst${index2}
          [#assign index2 = index2 + 1]
        [/#list]
        /* USER CODE END Declarations_TaskEx${index} */
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      [#if extendedtimers == 0]
      [#else]
        #n
        /* USER CODE BEGIN Declaration_TimerEx${index} */
        static void TimerEx${index}(void const* pData);#t#t#t#t#t// Prototype for TimerEx${index}
        osTimerDef (TimerEx${index}, TimerEx${index});#t#t#t#t#t#t#t#t#t// Definition of TimerEx${index}
        [#list 1..extendedtaskinst as j]
          osTimerId TimerEx${index}_Inst${index2};#t#t#t#t#t#t#t#t#t#t#t#t // Handle for TimerEx${index}_Inst${index2}
          [#assign index2 = index2 + 1]
        [/#list]
        /* USER CODE END Declaration_TimerEx${index}_Inst${index2} */
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mutexes == 0]
  [#else]
    [#list 1..mutexes as i]
      #n
      /* USER CODE BEGIN Declaration_Mutex${index} */
      osMutexDef (Mutex${index});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Definition of Mutex${index}
      osMutexId Mutex${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Handle for Mutex${index}
      /* USER CODE END Declaration_Mutex${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if semaphores == 0]
  [#else]
    [#list 1..semaphores as i]
      #n
      /* USER CODE BEGIN Declaration_Semaphore${index} */
      osSemaphoreDef (Semaphore${index});#t#t#t#t#t#t#t#t#t#t#t// Definition of Semaphore${index}
      osSemaphoreId Semaphore${index};#t#t#t#t#t#t#t#t#t#t#t#t // Handle for Semaphore${index}
      /* USER CODE END Declaration_Semaphore${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mailboxes == 0]
  [#else]
    [#list 1..mailboxes as i]
      #n
      /* USER CODE BEGIN Declarations_Mailbox${index} */
      osMessageQDef (Mailbox${index}, ${mailboxmsgnum} * ${mailboxmsgsize}, char);#t#t#t#t#t// Definition of Mailbox${index}
      osMessageQId Mailbox${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Handle for Mailbox${index}
      /* USER CODE END Declarations_Mailbox${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if queues == 0]
  [#else]
    [#list 1..queues as i]
      #n
      /* USER CODE BEGIN Declarations_Queue${index} */
      osMailQDef (Queue${index}, ${queuebuffersize}, char);#t#t#t#t#t#t#t#t#t // Definition of Queue${index}
      osMailQId Queue${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Handle for Queue${index}
      /* USER CODE END Declarations_Queue${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mempools == 0]
  [#else]
    [#list 1..mempools as i]
      #n
      /* USER CODE BEGIN Declarations_MemPool${index} */
      osPoolDef (MemPool${index}, ${mempoolblocknum}, char);#t#t#t#t#t#t#t#t#t // Definition of MemPool${index}
      osPoolId MemPool${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Handle for MemPool${index}
      /* USER CODE END Declarations_MemPool${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]
  #n

[/#compress]