[#ftl]
[#compress]

  [#assign stacksize         = 128]
  [#assign priority          = "osPriorityNormal"]
  [#assign extendedtasks     = 2]
  [#assign extendedtaskinst  = 1]

  [#assign extendedtimers    = 2]
  [#assign extendedtimerinst = 1]

  [#assign mutexes           = 0]

  [#assign semaphores        = 0]

  [#assign mailboxes         = 0]
  [#assign mailboxmsgnum     = 10]
  [#assign mailboxmsgsize    = 20]

  [#assign events            = 0]

  [#assign mempools          = 0]
  [#assign mempoolblocknum   = 10]
  [#assign mempoolblocksize  = 20]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_TASK_PRIORITY_CMSIS"]
          [#assign priority          = definition.value]
        [/#if]
        [#if definition.name == "OS_TASK_STACK_SIZE"]
          [#assign stacksize         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TASKS"]
          [#assign extendedtaskinst  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TIMERS"]
          [#assign timers            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores        = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_NUM_MESSAGES"]
          [#assign mailboxmsgnum     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_SIZE_MESSAGE"]
          [#assign mailboxmsgsize    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EVENTS"]
          [#assign events            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MEMPOOLS"]
          [#assign mempools          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_NUM_BLOCKS"]
          [#assign mempoolblocknum   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize  = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtasks  == 0]
  [#else]
    [#list 1..extendedtasks as i]
      [#if extendedtaskinst == 0]
      [#else]
        #n
        /* USER CODE BEGIN Declarations_TaskEx${index} */
        static void TaskEx${index}(void* pContext);#t#t#t#t// Prototype for TaskEx${index}
        static const osThreadAttr_t TaskEx${index}_attr = {"TaskEx${index}", osThreadDetached, NULL, 0, NULL, ${stacksize}, ${priority}, 0, 0};#t// Definition of TaskEx${index}
        [#list 1..extendedtaskinst as j]
          osThreadId_t TaskEx${index}_Inst${index2};#t#t#t#t#t#t#t#t#t#t#t#t // Handle for TaskEx${index}_Inst${index2}
          [#assign index2 = index2 + 1]
        [/#list]
        /* USER CODE END Declarations_TaskEx${index} */
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      [#if extendedtimers == 0]
      [#else]
        #n
        /* USER CODE BEGIN Declaration_TimerEx${index} */
        static void TimerEx${index}(void* pData);#t#t#t#t#t// Prototype for TimerEx${index}
        static const osTimerAttr_t TimerEx${index}_attr = {"TimerEx${index}", 0, NULL, 0};#t#t#t#t#t#t#t#t#t// Definition of TimerEx${index}
        [#list 1..extendedtaskinst as j]
          osTimerId_t TimerEx${index}_Inst${index2};#t#t#t#t#t#t#t#t#t#t#t#t // Handle for TimerEx${index}_Inst${index2}
          [#assign index2 = index2 + 1]
        [/#list]
        /* USER CODE END Declaration_TimerEx${index}_Inst${index2} */
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mutexes == 0]
  [#else]
    [#list 1..mutexes as i]
      #n
      /* USER CODE BEGIN Declaration_Mutex${index} */
      static const osMutexAttr_t Mutex${index}_attr = {"Mutex${index}", (osMutexRecursive | osMutexPrioInherit), NULL, 0};#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Definition of Mutex${index}
      osMutexId_t Mutex${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Handle for Mutex${index}
      /* USER CODE END Declaration_Mutex${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if semaphores == 0]
  [#else]
    [#list 1..semaphores as i]
      #n
      /* USER CODE BEGIN Declaration_Semaphore${index} */
      static const osSemaphoreAttr_t Semaphore${index}_attr = {"Semaphore${index}", 0, NULL, 0};#t#t#t#t#t#t#t#t#t#t#t// Definition of Semaphore${index}
      osSemaphoreId_t Semaphore${index};#t#t#t#t#t#t#t#t#t#t#t#t // Handle for Semaphore${index}
      /* USER CODE END Declaration_Semaphore${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mailboxes == 0]
  [#else]
    [#list 1..mailboxes as i]
      #n
      /* USER CODE BEGIN Declarations_Mailbox${index} */
      static const osMessageQueueAttr_t Mailbox${index}_attr = {"Mailbox${index}", 0, NULL, 0, NULL, 0};#t#t#t#t#t// Definition of Mailbox${index}
      osMessageQueueId_t Mailbox${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Handle for Mailbox${index}
      /* USER CODE END Declarations_Mailbox${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if events == 0]
  [#else]
    [#list 1..events as i]
      #n
      /* USER CODE BEGIN Declaration_EventObject${index} */
      static const osEventFlagsAttr_t EventObject${index}_attr = {"EventObject${index}", 0, NULL, 0};#t#t#t#t#t // Definition of EventObject${index}
      osEventFlagsId_t EventObject${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Handle for EventObject${index}
      /* USER CODE END Declaration_EventObject${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mempools == 0]
  [#else]
    [#list 1..mempools as i]
      #n
      /* USER CODE BEGIN Declarations_MemPool${index} */
      osMemoryPoolAttr_t MemPool${index}_attr = {"MemPool${index}", 0 , NULL, 0, NULL, 0};#t#t#t#t#t#t#t#t#t // Definition of MemPool${index}
      osMemoryPoolId_t MemPool${index};#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Handle for MemPool${index}
      /* USER CODE END Declarations_MemPool${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]
  #n

[/#compress]